architecture behavioral of shift_register is
begin
    
    shift_behavior : process is
                                 
        constant data_low : index_type := data_out'low;
        constant data_high : index_type := data_out'high;
                             
        subtype ascending_vector is vector ( data_low to data_high );
                             
        variable stored_data : ascending_vector;
                             
    begin
        data_out <= stored_data;
        wait until clk = '1';
        stored_data( data_low to index_type'pred(data_high) )
            := stored_data( index_type'succ(data_low) to data_high );
        stored_data( data_high ) := data_in;
    end process shift_behavior;
    
end architecture behavioral;
