architecture performance_modeling of motion_detector is

    type processing_step is ( raw, filtered );

    type image_token is
        record
            token_id : integer;
            degree_of_processing : processing_step;
        end record image_token;
	
    type image_channel is channel of image_token;
    
    component image_filter is
	    port ( channel raw_image : in image_channel;
		   channel filtered_image : out image_channel );
    end component image_filter;
    
    channel source_image, intermediate_image : image_channel;

begin
    filter : component image_filter
        port map ( raw_image => source_image,
                   filtered_image => intermediate_image );

end architecture performance_modeling;
